import { RectangularStructureParams } from "./rectangular_structure_params";
import { StructureFlowMode } from "./structure";
import { StructureGateCem88d } from "./structure_gate_cem88d";
import { LoiDebit } from "./structure_props";

export class StructureWeirCem88d extends StructureGateCem88d {

    constructor(prms: RectangularStructureParams, dbg: boolean = false) {
        super(prms, dbg);
        this._loiDebit = LoiDebit.WeirCem88d;
        this._isZDVcalculable = true;
        // Gestion de l'affichage l'ouverture de vanne
        this.prms.W.visible = false;
    }

    protected getFlowMode(): StructureFlowMode {
        return StructureFlowMode.WEIR;
    }

}
